\documentclass[a4paper,12pt,border=5pt]{standalone}
\usepackage[utf8]{inputenc}
\usepackage{tikz}
\usetikzlibrary{fit, backgrounds, arrows, calc, decorations.pathmorphing, positioning}
\tikzset{%
    snake arrow/.style=
        {->, thick,
        decorate,
        decoration={snake,
            amplitude=.4mm,
            segment length=2mm,
            post length=1mm}},
    thread/.pic={
        \node[fill=gray!0,
            label={[anchor=north,
                        name=th]90:\textit{Thread} (\the\pgfmatrixcurrentcolumn,\the\pgfmatrixcurrentrow)},
            minimum width=3cm,
            minimum height=2.5cm,
            draw] (Th) {};
        \draw[thick] (th.south) edge[snake arrow] ++(-90:15mm);
},
    block/.pic={
        \node[fill=gray!10,
            label={[anchor=north,
                        name=bl]90:\textit{Block} (\the\pgfmatrixcurrentcolumn,\the\pgfmatrixcurrentrow)},
            minimum width=3cm,
            minimum height=2.5cm,
            draw] (Bl) {};
        \foreach \i in {-6,-4,...,6}\draw[thick] ([xshift=\i mm]bl.south) edge[snake arrow] ++(-90:15mm);
}

}


\begin{document}

\begin{tikzpicture}

\matrix[label={[anchor=south west, name=gl]north west:\textit{Grid}}] (OneGrid) [column sep=1mm, row sep=1mm]
{
	\pic{block}; & \pic{block}; & \pic{block}; \\
	\pic{block}; & \pic (Ref) {block}; & \pic{block}; \\
};
\begin{scope}[on background layer]
\node[fit=(OneGrid) (gl), inner sep=0pt, fill=gray!50, draw=gray] (Grid) {};
\end{scope}


\matrix[label={[name=ml]\textit{Block}(2,2)}, below=2cm of Grid] (OneBlock) [column sep=-\pgflinewidth, row sep=\pgflinewidth]
{
	\pic{thread}; & \pic{thread}; & \pic{thread}; & \pic{thread}; \\
	\pic{thread}; & \pic{thread}; & \pic{thread}; & \pic{thread}; \\
	\pic{thread}; & \pic{thread}; & \pic{thread}; & \pic{thread}; \\
};
\begin{scope}[on background layer]
\node[fit=(OneBlock) (ml), inner sep=0pt, fill=gray!10, draw=gray] (Block) {};
\end{scope}

\draw[dashed] (RefBl.north west) -- (Block.north west);
\draw[dashed] (RefBl.north east) -- (Block.north east);
\draw[dashed] (RefBl.south west) -- (Block.south west);
\draw[dashed] (RefBl.south east) -- (Block.south east);


\begin{scope}[]
\node[fit=(OneBlock) (ml), inner sep=0pt, fill=gray!10, draw=gray] (Block) {};
\end{scope}
\matrix[label={[name=ml]\textit{Block}(2,2)}, below=2cm of Grid] (OneBlock) [column sep=-\pgflinewidth, row sep=\pgflinewidth]
{
	\pic{thread}; & \pic{thread}; & \pic{thread}; & \pic{thread}; \\
	\pic{thread}; & \pic{thread}; & \pic{thread}; & \pic{thread}; \\
	\pic{thread}; & \pic{thread}; & \pic{thread}; & \pic{thread}; \\
};

\end{tikzpicture}

\end{document}
